:
# RCSid:
#	$Id: atexit.sh,v 1.8 2004/12/28 19:55:36 sjg Exp $
#
#	@(#) Copyright (c) 1993 Simon J. Gerraty
#
#	This file is provided in the hope that it will
#	be of use.  There is absolutely NO WARRANTY.
#	Permission to copy, redistribute or otherwise
#	use this file is hereby granted provided that 
#	the above copyright notice and this notice are
#	left intact. 
#      
#	Please send copies of changes and bug-fixes to:
#	sjg@crufty.net
#

_ATEXIT_SH=:

# a semi-reliable atexit() facility
atexit() {
	case "$1" in
	""|:)	# someone just wants to initialize us
		# this is depricated due to ksh sillyness.
		;;
	*)	at_exit="$*;$at_exit"
		;;
	esac
}

Exit() {
	ExitStatus=$1
	exit_sts=$1
	exit $1
}

# we have to do this out here, because if done within
# the function, ksh exits on return from the function!
_at_exit_init="trap 0; eval exit '\${ExitStatus:-\${exit_sts:-${ExitStatus:-${exit_sts:-0}}}}'"
at_exit=${at_exit:-$_at_exit_init}
trap "Exit 1" 1 2 3 15
trap 'eval $at_exit' 0

